package com.capgemini.reports.snecmaobjects.part;

import com.capgemini.framework.teamcenter.authent.TcSession;
import com.capgemini.reports.snecmaobjects.visitor.IComponentVisitor;
import com.capgemini.reports.snecmaobjects.visitor.IReceptorVisitor;
import com.teamcenter.soa.client.model.strong.ItemRevision;

import static com.capgemini.framework.teamcenter.object.SnecmaObjectProperties.PV_FOURNISSEURS;
import static com.capgemini.framework.teamcenter.object.SnecmaObjectProperties.PV_TYPE_STANDARD;
import static com.capgemini.framework.teamcenter.object.types.SnecmaObjectTypes.STANDARD_REVISION;

/**
 * Class representing a StandardRevision.
 */
public class StandardRevision extends AbstractPart {
    private static final long serialVersionUID = 3254104726494033602L;

    public StandardRevision(final TcSession session, final ItemRevision itemRevision) {
        super(session, itemRevision);
    }

    public String[] getLstFournisseurs() {
        return itemRevision.getPropertyObject(PV_FOURNISSEURS).getStringArrayValue();
    }

    public String getTypeStandard() {
        return getMasterFormRev().getPropertyObject(PV_TYPE_STANDARD).getStringValue();
    }

    @Override
    public <T> T accept(final IReceptorVisitor<T> aReceptorVisitor) {
        return aReceptorVisitor.visitReceptor(this);
    }

    @Override
    public <T> T accept(final IComponentVisitor<T> aComponentVisitor) {
        return aComponentVisitor.visitComponent(this);
    }

    @Override
    public boolean isSuperModel() {
        return false;
    }

    @Override
    public String toString() {
        return STANDARD_REVISION + " " + this.getItemId();
    }
}
